mod_gui = require('mod-gui')

script.on_event({defines.events.on_gui_click}, function(event)
   if(event.element.name == 'reload-mods-redux-tool-button') then
      log("\n============== Reloading Mods ==============")
      game.reload_mods()
   end
end)

local function create_gui(e)
   for i, player in pairs(game.players) do
      local flow = mod_gui.get_button_flow(player)
      if not flow['reload-mods-redux-tool-button'] then
        flow.add{ type = "sprite-button", name = 'reload-mods-redux-tool-button',
          sprite = 'reload-mods-redux-tool-button', style = mod_gui.button_style,
          tooltip = "Reload all mods" }
      end
   end
end

script.on_configuration_changed(create_gui)
script.on_event(defines.events.on_player_created, create_gui)
script.on_event(defines.events.on_player_joined_game, create_gui)

