--[[
Eventually, this mod will be configurable using per player settings(maybe) to
 test when an event gets fired, and what event data is there.
--]]
 
local function on_event_fired(event)
	log("\nEvent: on_player_setup_blueprint\n" ..
		"Event data:\n" .. serpent.block(event))
	
	local p = game.players[event.player_index]
	local bp = p.blueprint_to_setup
	log("Blueprint via 'blueprint_to_setup' valid for read: " .. ((bp.valid_for_read and "true") or "false"))
	if not (bp and bp.is_blueprint) then
		log("valid blueprint not found via `blueprint_to_setup` trying player.cursor_stack...")
		bp = p.cursor_stack
	end
	if (bp and bp.valid_for_read and bp.is_blueprint) then
		local bp_es = bp.get_blueprint_entities()
		local bp_map = event.mapping.valid and event.mapping.get()
		local nmap = {}
		for i,e in pairs(bp_map) do
			if e.valid then 
				nmap[i] = e.name
			end
		end
		log("\nbp entities data:\n" .. serpent.block(bp_es) ..
			"\nbp mapping data :\n" .. serpent.block(bp_map) ..
			"\nbp name mapping :\n" .. serpent.block(nmap))
	else
		log("cannot find blueprint!")
	end
end

script.on_event(defines.events.on_player_setup_blueprint, on_event_fired)
